<?php
/** 
*
* @package phpAR
* @version $Id: arcade.php
* @copyright (c) 2007 gfxPros
* @website http://www.gfx-pros.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/arcade');
// End session management

// Output page
page_header($user->lang['ARCADE']);

$template->set_filenames(array(
	'body' => 'arcade_body.html'
));

$action	= request_var('action', '');
$game_id = request_var('g', 0);

switch ($action)
{
	case 'remove':
		$sql = 'SELECT favorite_id FROM ' . AR_FAVORITES_TABLE . '
			WHERE favorite_user = ' . $user->data['user_id'] . "
				AND favorite_game = $game_id";
		$result = $db->sql_query($sql);
		$favorite_id = (int) $db->sql_fetchfield('favorite_id');
		$db->sql_freeresult($result);
		if ($favorite_id)
		{
			$sql = 'DELETE FROM ' . AR_FAVORITES_TABLE . ' WHERE favorite_id = ' . (int) $favorite_id;
			$db->sql_query($sql);
		}
	break;
	case 'add':
		$sql = 'SELECT favorite_id FROM ' . AR_FAVORITES_TABLE . '
			WHERE favorite_user = ' . $user->data['user_id'] . "
				AND favorite_game = $game_id";
		$result = $db->sql_query($sql);
		$favorite_id = (int) $db->sql_fetchfield('favorite_id');
		$db->sql_freeresult($result);
		if (!$favorite_id)
		{
			$sql_ary = array(
				'favorite_game'		=> $game_id,
				'favorite_user'		=> $user->data['user_id']
			);
			$sql = 'INSERT INTO ' . AR_FAVORITES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
		}
	break;
	case 'rategame':
		$rating	= request_var('rating', 0);
		// Grab group details for rating display
		$sql = 'SELECT rating_id FROM ' . AR_RATINGS_TABLE . '
			WHERE rating_user = ' . $user->data['user_id'] . "
				AND rating_game = $game_id";
		$result = $db->sql_query($sql);
		$rating_id = (int) $db->sql_fetchfield('rating_id');
		$db->sql_freeresult($result);
		if ($rating_id)
		{
			// Update number of game plays this game has been played
			$sql = 'UPDATE ' . AR_RATINGS_TABLE . ' SET rating_score = ' . $rating . ' WHERE rating_id = '. $rating_id;
			$db->sql_query($sql);
		}
		else
		{
			// Update number of game plays this game has been played
			$sql_ary = array(
				'rating_game'		=> $game_id,
				'rating_user'		=> $user->data['user_id'],
				'rating_score'		=> $rating
			);
			$sql = 'INSERT INTO ' . AR_RATINGS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
		}
		// Grab group details for rating display
		$sql = 'SELECT COUNT(rating_game) AS row_count FROM ' . AR_RATINGS_TABLE . " WHERE rating_game = $game_id";
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		$db->sql_freeresult($result);

		$sql = 'SELECT rating_game, rating_score
			FROM ' . AR_RATINGS_TABLE . '
			WHERE rating_game = ' . $game_id;
		$result = $db->sql_query($sql);
		$rtotal = 0;
		while ($row = $db->sql_fetchrow($result))
		{
			$game_id = $row['rating_game'];
			$rtotal += $row['rating_score'];
		}
		$db->sql_freeresult($result);
		$rtotal = number_format($rtotal / $row_count, 0);
		$sql_ary = array(
			'game_rating'		=> $rtotal,
			'game_num_ratings'	=> $row_count
		);
		$sql = 'UPDATE ' . AR_GAMES_TABLE . '
			SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
			WHERE game_id = ' . (int) $game_id;
		$db->sql_query($sql);
	break;
}

$template->assign_block_vars('navlinks', array(
	'ARCADE_NAME'	=> $user->lang['ARCADE'],
	'U_VIEW_ARCADE'	=> append_sid("{$phpbb_root_path}arcade.$phpEx"))
);

// Grab game details for category display
$sql = 'SELECT category_id, category_name
	FROM ' . AR_CATEGORIES_TABLE . '
	ORDER BY category_name';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	// Grab game details for a total count for the category
	$sql = 'SELECT COUNT(game_category) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_category = ' . $row['category_id'];
	$result2 = $db->sql_query($sql);
	$row_count = (int) $db->sql_fetchfield('row_count');
	$db->sql_freeresult($result2);

	// Send vars to template
	$template->assign_block_vars('categoryrow', array(
			'CATEGORY_ID'			=> $row['category_id'],
			'CATEGORY_NAME'			=> $row['category_name'],
			'CATEGORY_COUNT'		=> '(' . $row_count . ')'
	));
}
$db->sql_freeresult($result);

// Check if guests can view the arcade
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 1 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
$db->sql_freeresult($result);
if ($row_count)
{
	$template->assign_vars(array(
			'S_VIEW'		=> true
	));
}
if ($user->data['is_registered'])
{
	$template->assign_vars(array(
			'S_VIEW'		=> true,
			'S_REG'		=> true
	));
}

// Grab game details for a total count
$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE;
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
$db->sql_freeresult($result);
if ($row_count > 1)
{
	$template->assign_vars(array(
		'L_NUM_GAMES'	=> $user->lang['TOTAL_OF'] . $row_count . $user->lang['GAMES_IN_ARCADE'],
		'S_ARCADE'		=> true
	));
}
elseif ($row_count == 1)
{
	$template->assign_vars(array(
		'L_NUM_GAMES'	=> $user->lang['TOTAL_OF'] . $row_count . $user->lang['GAME_IN_ARCADE'],
		'S_ARCADE'		=> true
	));
}
else
{
	$template->assign_vars(array(
		'L_NUM_GAMES'	=> $user->lang['NONE_IN_ARCADE'],
		'S_ARCADE'		=> true
	));
}
// Grab game details for a favorites count
$sql = 'SELECT COUNT(favorite_id) AS row_count FROM ' . AR_FAVORITES_TABLE . ' WHERE favorite_user = ' . $user->data['user_id'];
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
$db->sql_freeresult($result);
if ($row_count > 1)
{
	$template->assign_vars(array(
		'L_FAV_GAMES'	=> $user->lang['YOU_HAVE'] . '<a href="ucp.php?i=arcade&mode=favorites">' . $row_count . '</a>' . $user->lang['GAMES_FAVORITED']
	));
}
elseif ($row_count == 1)
{
	$template->assign_vars(array(
		'L_FAV_GAMES'	=> $user->lang['YOU_HAVE'] . '<a href="ucp.php?i=arcade&mode=favorites">' . $row_count . '</a>' . $user->lang['GAME_FAVORITED']
	));
}
else
{
	$template->assign_vars(array(
		'L_FAV_GAMES'	=> $user->lang['NONE_FAVORITED']
	));
}

// Grab game details for game display based on date added
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	ORDER BY game_id DESC
	LIMIT 10';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($user->data['user_id'] != ANONYMOUS)
	{
		$rate = $phpbb_root_path . 'arcade.php?&g=' . $row['game_id'] . '&action=rategame&rating=';
		$starbegin = "<a href='" . $rate;
		$staryes =  "'><img src='$phpbb_root_path/arcade/images/star_yes.gif' alt='*' /></a>";
		$star = "'><img src='$phpbb_root_path/arcade/images/star.gif' alt='*' /></a>";
		if ($row['game_rating'] == 0)
		{
			$rstars = $starbegin . '1' . $star . $starbegin . '2' . $star . $starbegin . '3' . $star . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 1)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $star . $starbegin . '3' . $star . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 2)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $star . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 3)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $staryes . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 4)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $staryes . $starbegin . '4' . $staryes . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 5)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $staryes . $starbegin . '4' . $staryes . $starbegin . '5' . $staryes;
		}
		$sql = 'SELECT favorite_id FROM ' . AR_FAVORITES_TABLE . '
			WHERE favorite_user = ' . $user->data['user_id'] . '
				AND favorite_game = ' . $row['game_id'];
		$result2 = $db->sql_query($sql);
		$favorite_id = (int) $db->sql_fetchfield('favorite_id');
		$db->sql_freeresult($result2);
		if ($favorite_id)
		{
			$game_add_remove = "<img src='$phpbb_root_path/arcade/images/star_r.gif' alt='*' />";
			$u_add_remove = 'arcade.php?action=remove&g=' . $row['game_id'];
		}
		else
		{
			$game_add_remove = "<img src='$phpbb_root_path/arcade/images/star_p.gif' alt='*' />";
			$u_add_remove = 'arcade.php?action=add&g=' . $row['game_id'];
		}
	}
	else
	{
		$staryes =  "<img src='$phpbb_root_path/arcade/images/star_yes.gif' alt='*' />";
		$star = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='*' />";
		if ($row['game_rating'] == 0)
		{
			$rstars = $star . $star . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 1)
		{
			$rstars = $staryes . $star . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 2)
		{
			$rstars = $staryes . $staryes . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 3)
		{
			$rstars = $staryes . $staryes . $staryes . $star . $star;
		}
		elseif ($row['game_rating'] == 4)
		{
			$rstars = $staryes . $staryes . $staryes . $staryes . $star;
		}
		elseif ($row['game_rating'] == 5)
		{
			$rstars = $staryes . $staryes . $staryes . $staryes . $staryes;
		}
	}
	// Send vars to template
	$filesize = floor($row['game_filesize']/1024);
	$template->assign_block_vars('latestrow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> $filesize . 'kB',
			'GAME_ADD_REMOVE'	=> $game_add_remove,
			'U_ADD_REMOVE'		=> $u_add_remove
	));
}
$db->sql_freeresult($result);

// Grab game details for game display based on plays
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	ORDER BY game_plays DESC
	LIMIT 10';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($user->data['user_id'] != ANONYMOUS)
	{
		$rate = $phpbb_root_path . 'arcade.php?&g=' . $row['game_id'] . '&action=rategame&rating=';
		$starbegin = "<a href='" . $rate;
		$staryes =  "'><img src='$phpbb_root_path/arcade/images/star_yes.gif' alt='*' /></a>";
		$star = "'><img src='$phpbb_root_path/arcade/images/star.gif' alt='*' /></a>";
		if ($row['game_rating'] == 0)
		{
			$rstars = $starbegin . '1' . $star . $starbegin . '2' . $star . $starbegin . '3' . $star . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 1)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $star . $starbegin . '3' . $star . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 2)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $star . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 3)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $staryes . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 4)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $staryes . $starbegin . '4' . $staryes . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 5)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $staryes . $starbegin . '4' . $staryes . $starbegin . '5' . $staryes;
		}
		$sql = 'SELECT favorite_id FROM ' . AR_FAVORITES_TABLE . '
			WHERE favorite_user = ' . $user->data['user_id'] . '
				AND favorite_game = ' . $row['game_id'];
		$result2 = $db->sql_query($sql);
		$favorite_id = (int) $db->sql_fetchfield('favorite_id');
		$db->sql_freeresult($result2);
		if ($favorite_id)
		{
			$game_add_remove = "<img src='$phpbb_root_path/arcade/images/star_r.gif' alt='*' />";
			$u_add_remove = 'arcade.php?action=remove&g=' . $row['game_id'];
		}
		else
		{
			$game_add_remove = "<img src='$phpbb_root_path/arcade/images/star_p.gif' alt='*' />";
			$u_add_remove = 'arcade.php?action=add&g=' . $row['game_id'];
		}
	}
	else
	{
		$staryes =  "<img src='$phpbb_root_path/arcade/images/star_yes.gif' alt='*' />";
		$star = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='*' />";
		if ($row['game_rating'] == 0)
		{
			$rstars = $star . $star . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 1)
		{
			$rstars = $staryes . $star . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 2)
		{
			$rstars = $staryes . $staryes . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 3)
		{
			$rstars = $staryes . $staryes . $staryes . $star . $star;
		}
		elseif ($row['game_rating'] == 4)
		{
			$rstars = $staryes . $staryes . $staryes . $staryes . $star;
		}
		elseif ($row['game_rating'] == 5)
		{
			$rstars = $staryes . $staryes . $staryes . $staryes . $staryes;
		}
	}
	// Send vars to template
	$filesize = floor($row['game_filesize']/1024);
	$template->assign_block_vars('playedrow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> $filesize . 'kB',
			'GAME_ADD_REMOVE'	=> $game_add_remove,
			'U_ADD_REMOVE'		=> $u_add_remove
	));
}
$db->sql_freeresult($result);

// Grab game details for game display based on rating
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	ORDER BY game_rating DESC, game_num_ratings DESC
	LIMIT 10';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($user->data['user_id'] != ANONYMOUS)
	{
		$rate = $phpbb_root_path . 'arcade.php?&g=' . $row['game_id'] . '&action=rategame&rating=';
		$starbegin = "<a href='" . $rate;
		$staryes =  "'><img src='$phpbb_root_path/arcade/images/star_yes.gif' alt='*' /></a>";
		$star = "'><img src='$phpbb_root_path/arcade/images/star.gif' alt='*' /></a>";
		if ($row['game_rating'] == 0)
		{
			$rstars = $starbegin . '1' . $star . $starbegin . '2' . $star . $starbegin . '3' . $star . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 1)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $star . $starbegin . '3' . $star . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 2)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $star . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 3)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $staryes . $starbegin . '4' . $star . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 4)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $staryes . $starbegin . '4' . $staryes . $starbegin . '5' . $star;
		}
		elseif ($row['game_rating'] == 5)
		{
			$rstars = $starbegin . '1' . $staryes . $starbegin . '2' . $staryes . $starbegin . '3' . $staryes . $starbegin . '4' . $staryes . $starbegin . '5' . $staryes;
		}
		$sql = 'SELECT favorite_id FROM ' . AR_FAVORITES_TABLE . '
			WHERE favorite_user = ' . $user->data['user_id'] . '
				AND favorite_game = ' . $row['game_id'];
		$result2 = $db->sql_query($sql);
		$favorite_id = (int) $db->sql_fetchfield('favorite_id');
		$db->sql_freeresult($result2);
		if ($favorite_id)
		{
			$game_add_remove = "<img src='$phpbb_root_path/arcade/images/star_r.gif' alt='*' />";
			$u_add_remove = 'arcade.php?action=remove&g=' . $row['game_id'];
		}
		else
		{
			$game_add_remove = "<img src='$phpbb_root_path/arcade/images/star_p.gif' alt='*' />";
			$u_add_remove = 'arcade.php?action=add&g=' . $row['game_id'];
		}
	}
	else
	{
		$staryes =  "<img src='$phpbb_root_path/arcade/images/star_yes.gif' alt='*' />";
		$star = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='*' />";
		if ($row['game_rating'] == 0)
		{
			$rstars = $star . $star . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 1)
		{
			$rstars = $staryes . $star . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 2)
		{
			$rstars = $staryes . $staryes . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 3)
		{
			$rstars = $staryes . $staryes . $staryes . $star . $star;
		}
		elseif ($row['game_rating'] == 4)
		{
			$rstars = $staryes . $staryes . $staryes . $staryes . $star;
		}
		elseif ($row['game_rating'] == 5)
		{
			$rstars = $staryes . $staryes . $staryes . $staryes . $staryes;
		}
	}
	// Send vars to template
	$filesize = floor($row['game_filesize']/1024);
	$template->assign_block_vars('ratingrow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> $filesize . 'kB',
			'GAME_ADD_REMOVE'	=> $game_add_remove,
			'U_ADD_REMOVE'		=> $u_add_remove
	));
}
$db->sql_freeresult($result);

page_footer();

?>