<?php
/** 
*
* @package acp
* @version $Id: acp_arcade.php
* @copyright (c) 2007 gfxPros
* @website http://www.gfx-pros.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @package acp
*/
class acp_arcade
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		// Set up general vars
		$action	= request_var('action', '');

		$this->tpl_name = 'acp_arcade';
		$this->page_title = 'Arcade Room';
		
		$user->add_lang('mods/arcade');
		
		require($phpbb_root_path . 'includes/file_functions.' . $phpEx);

		$sync = false;

		switch ($action)
		{
			case 'update':
				require($phpbb_root_path . 'includes/pclzip.lib.' . $phpEx);
				$requestfile = 'http://www.gfx-pros.com/phpAR2/phpARversion.txt';
				$newfile = 'phpARversion.txt';
				if (@copy($requestfile, $newfile))
				{
					$newver = file_get_contents($newfile);
					$curver = $user->lang['AR_VERSION'];
					unlink($newfile);
				}
				$requestfile = 'http://www.gfx-pros.com/phpAR2/'.$curver.'-'.$newver.'.zip';
				$newfile = '../phpARbeta.zip';
				if (@copy($requestfile, $newfile))
				{
					$archive = new PclZip($newfile);
					if (@$archive -> extract(PCLZIP_OPT_PATH, '../'))
					{
						unlink($newfile);
						header("Location: ../update.php");
					}
				}
			break;
			case 'resetratings':
				$rating_id = array();
				$game_id = array();
				$sql = 'SELECT *
					FROM ' . AR_RATINGS_TABLE;
				$result = $db->sql_query($sql);
				$num = sizeof($result);
				while ($row = $db->sql_fetchrow($result))
				{
					$rating_id[$row['rating_id']] = $row['rating_id'];
				}
				foreach ($rating_id as $rid)
				{
					$sql = 'DELETE FROM ' . AR_RATINGS_TABLE . ' WHERE rating_id = ' . (int) $rid;
					$db->sql_query($sql);
				}
				$sql = 'SELECT *
					FROM ' . AR_GAMES_TABLE;
				$result = $db->sql_query($sql);
				$num = sizeof($result);
				while ($row = $db->sql_fetchrow($result))
				{
					$game_id[$row['game_id']] = $row['game_id'];
				}
				foreach ($game_id as $gid)
				{
					$sql_ary = array(
						'game_rating'		=> 0,
						'game_num_ratings'	=> 0
					);
					$sql = 'UPDATE ' . AR_GAMES_TABLE . ' 
						SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
						WHERE game_id = ' . (int) $gid;
					$db->sql_query($sql);
				}
				trigger_error($user->lang['RATINGS_RESET'] . adm_back_link($this->u_action));
			break;
			case 'resetratingsgame':
				$rating_id = array();
				$game_id = array();
				$gid = request_var('g', 0);
				$sql = 'SELECT *
					FROM ' . AR_RATINGS_TABLE;
				$result = $db->sql_query($sql);
				$num = sizeof($result);
				while ($row = $db->sql_fetchrow($result))
				{
					$rating_id[$row['rating_id']] = $row['rating_id'];
				}
				foreach ($rating_id as $rid)
				{
					$sql = 'DELETE FROM ' . AR_RATINGS_TABLE . ' WHERE rating_id = ' . (int) $rid . ' AND rating_game = ' . (int) $gid;
					$db->sql_query($sql);
				}
				$sql = 'SELECT *
					FROM ' . AR_GAMES_TABLE . '
					WHERE game_id = ' . (int) $gid;
				$result = $db->sql_query($sql);
				$num = sizeof($result);
				while ($row = $db->sql_fetchrow($result))
				{
					$game_id[$row['game_id']] = $row['game_id'];
				}
				foreach ($game_id as $gid)
				{
					$sql_ary = array(
						'game_rating'		=> 0,
						'game_num_ratings'	=> 0
					);
					$sql = 'UPDATE ' . AR_GAMES_TABLE . ' 
						SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
						WHERE game_id = ' . (int) $gid;
					$db->sql_query($sql);
				}
				trigger_error($user->lang['RATING_RESET'] . adm_back_link($this->u_action));
			break;
			case 'resethighscores':
				$highscore_id = array();
				$sql = 'SELECT *
					FROM ' . AR_HIGHSCORES_TABLE;
				$result = $db->sql_query($sql);
				$num = sizeof($result);
				while ($row = $db->sql_fetchrow($result))
				{
					$sql = 'DELETE FROM ' . AR_HIGHSCORES_TABLE . ' WHERE highscore_id = ' . $row['highscore_id'];
					$db->sql_query($sql);
				}
				trigger_error($user->lang['HIGHSCORES_RESET'] . adm_back_link($this->u_action));
			break;
			case 'resethighscoresgame':
				$highscore_id = array();
				$gid = request_var('g', 0);
				$sql = 'SELECT *
					FROM ' . AR_HIGHSCORES_TABLE;
				$result = $db->sql_query($sql);
				$num = sizeof($result);
				while ($row = $db->sql_fetchrow($result))
				{
					$sql = 'DELETE FROM ' . AR_HIGHSCORES_TABLE . ' WHERE highscore_id = ' . $row['highscore_id'] . ' AND highscore_game = ' . (int) $gid;
					$db->sql_query($sql);
				}
				trigger_error($user->lang['HIGHSCORE_RESET'] . adm_back_link($this->u_action));
			break;
			case 'deletecategory':
				$category_id = request_var('c', 0);
				$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_category = ' . (int) $category_id;
				$result = $db->sql_query($sql);
				$row_count = (int) $db->sql_fetchfield('row_count');
				$db->sql_freeresult($result);
				if ($row_count)
				{
					trigger_error($user->lang['CAT_HAS_GAMES'] . adm_back_link($this->u_action), E_USER_WARNING);
				}
				else
				{
					$sql = 'DELETE
						FROM ' . AR_CATEGORIES_TABLE . '
						WHERE category_id = ' . (int) $category_id;
					$db->sql_query($sql);
					trigger_error($user->lang['CATEGORY_REMOVED'] . adm_back_link($this->u_action));
				}
			break;
			case 'deletegame':
				$game_id = request_var('g', 0);
				// Grab game details for game display
				$sql = 'SELECT game_image, game_filename
					FROM ' . AR_GAMES_TABLE . '
					WHERE game_id = ' . (int) $game_id;
				$result = $db->sql_query($sql);
				$db->sql_freeresult($result);
				while ($row = $db->sql_fetchrow($result))
				{
					$addurl = $this->u_action;
					$gamefile = $phpbb_root_path . "arcade/" . $row['game_filename']; 
					unlink($gamefile);
					if ($row['game_image'] != 'no_image.gif')
					{
						$imagefile = $phpbb_root_path . "arcade/images/" . $row['game_image'];
						unlink($imagefile);
					}
				}
				// Grab game details for category display
				$sql = 'DELETE
					FROM ' . AR_GAMES_TABLE . '
					WHERE game_id = ' . (int) $game_id;
				$db->sql_query($sql);
				trigger_error($user->lang['GAME_REMOVED'] . adm_back_link($this->u_action));
			break;
			case 'addcategory':
				$category_name = request_var('category_name', '');
				// Grab game details for category display
				$sql_ary = array(
					'category_name'			=> $category_name,
				);
				$sql = 'INSERT INTO ' . AR_CATEGORIES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
				$db->sql_query($sql);
				trigger_error($user->lang['CATEGORY_ADDED'] . adm_back_link($this->u_action));
			break;
			case 'addgame':
				$category_id = request_var('c', 0);
				$game_name = request_var('game_name', '');
				// Grab game details for category display
				$sql = 'SELECT category_id, category_name
					FROM ' . AR_CATEGORIES_TABLE . '
					ORDER BY category_name';
				$result = $db->sql_query($sql);
				$db->sql_freeresult($result);
				while ($row = $db->sql_fetchrow($result))
				{
					$url = $this->u_action . "&amp;c={$row['category_id']}";
					
					$extra = '';
					if ($category_id == $row['category_id'])
					{
						$extra = ' selected="selected"';
					}
					
					// Send vars to template
					$template->assign_block_vars('categoryrow', array(
							'CATEGORY_CODE'	=> '<option value="' . $row['category_id'] .'"' . $extra . '>' . $row['category_name'] . '</option>'
					));
				}
				$url = $this->u_action . "&amp;c=$category_id";
				$template->assign_var('S_ADD_GAME', true);
				$template->assign_vars(array(
					'L_GAME_NAME'	=>	$game_name,
					'L_CATEGORY_ID'	=>	$category_id,
					'L_GAME_HEIGHT'	=>	'',
					'L_GAME_WIDTH'	=>	'',
					'L_GAME_DIR'	=>	'',
					'L_GAME_DESC'	=>	'',
				));
				$sync = true;
			break;
			case 'addgameinfo':
				$errors = false;
				$error_message = '';
				$game_file_name = file_temp_name('.swf');
				$uploadgamespot = $phpbb_root_path . "arcade/" . $game_file_name; 
				$image_file_name = file_temp_name('.' . $game_image_type);
				$uploadimagespot = $phpbb_root_path . "arcade/images/" . $image_file_name;
				if (file_exists($uploadgamespot) && $uploadgamespot != $phpbb_root_path . "arcade/")
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['GAME_DUP'] . '<br />'
					));
				}
				if (file_exists($uploadimagespot) && $uploadimagespot != $phpbb_root_path . "arcade/images/")
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['GAME_DUP'] . '<br />'
					));
				}
				$game_file_type = get_file_type($_FILES['game_file']['name']);
				if ($_FILES['game_file']['name'] == '')
				{
				$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['UP_GAME'] . '<br />'
					));
				}
				elseif ($game_file_type != 'swf')
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['WRONG_GAME_TYPE'] . '<br />'
					));
				}
				$game_image_type = get_file_type($_FILES['game_image']['name']);
				if ($game_image_type != 'gif' && $game_image_type != 'jpeg' && $game_image_type != 'jpg' && $game_image_type != 'png' && $_FILES['game_image']['name'] != '')
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['WRONG_IMAGE_TYPE'] . '<br />'
					));
				}
				$info = getimagesize($_FILES['game_image']['tmp_name']);
				$create_thumb = false;
				if ($info[0] > 75 || $info[1] > 50)
				{
					$create_thumb = true;
				}
				$game_name = request_var('game_name', '');
				if (!$game_name)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_NAME'] . '<br />'
					));
				}
				$game_highscore = request_var('game_highscore', 0);
				if ($game_highscore != 1)
				{
					$game_highscore = 0;
				}
				$game_newscore = request_var('game_newscore', 0);
				if ($game_newscore != 1)
				{
					$game_newscore = 0;
				}
				else
				{
					$game_highscore = 1;
				}
				$game_height = request_var('game_height', '');
				if (!$game_height)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_HEIGHT'] . '<br />'
					));
				}
				$game_width = request_var('game_width', '');
				if (!$game_width)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_WIDTH'] . '<br />'
					));
				}
				$game_dir = request_var('game_dir', '');
				if (!$game_dir)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_DIR'] . '<br />'
					));
				}
				$game_cat = request_var('game_cat', '');
				if (!$game_cat)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_CAT'] . '<br />'
					));
				}
				$game_desc = request_var('game_desc', '');
				if (!$game_desc)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_DESC'] . '<br />'
					));
				}
				$game_cat = request_var('game_cat', '');
				$sql = 'SELECT *
					FROM ' . AR_CATEGORIES_TABLE . '
					WHERE category_id = ' . (int) $game_cat;
				$result = $db->sql_query($sql);
				$db->sql_freeresult($result);
				while ($row = $db->sql_fetchrow($result))
				{
					$game_cat = $row['category_name'];
				}
				if (!$errors)
				{
					if(move_uploaded_file($_FILES['game_file']['tmp_name'], $uploadgamespot))
					{
						$game_size = $_FILES['game_file']['size'];
						$game_name = request_var('game_name', '');
						$template->assign_vars(array(
							'L_GAME_NAME'	=>	$game_name,
							'L_GAME_HEIGHT'	=>	$game_height,
							'L_GAME_WIDTH'	=>	$game_width,
							'L_GAME_DIR'	=>	$game_dir,
							'L_GAME_DESC'	=>	$game_desc,
							'L_GAMECAT'		=>	$game_cat,
						));
						if($_FILES['game_image']['name'] != '')
						{
							if ($create_thumb != true)
							{
								if(!move_uploaded_file($_FILES['game_image']['tmp_name'], $uploadimagespot))
								{
									$template->assign_vars(array(
										'L_GAME_ERROR'	=>	$user->lang['ERROR_IMAGE']
									));
									$template->assign_var('S_ERROR', true);
								}
							}
							else
							{
								$sresult = create_thumbnail($_FILES['game_image']['tmp_name'], $uploadimagespot, 75);
							}
						}
						else
						{
							$image_file_name = 'no_image.gif';
						}
						$game_cat = request_var('game_cat', '');
						$sql_ary = array(
							'game_name'			=> $game_name,
							'game_image'		=> $image_file_name,
							'game_directions'	=> $game_dir,
							'game_description'	=> $game_desc,
							'game_category'		=> $game_cat,
							'game_filename'		=> $game_file_name,
							'game_filesize'		=> $game_size,
							'game_width'		=> $game_width,
							'game_height'		=> $game_height,
							'game_highscore'	=> $game_highscore,
							'game_newscore'		=> $game_newscore
						);
						$sql = 'INSERT INTO ' . AR_GAMES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
						$db->sql_query($sql);
						$game_cat = request_var('game_cat', '');
						// Grab game details for category display
						trigger_error($user->lang['GAME_ADDED'] . adm_back_link($this->u_action . "&amp;c=$game_cat"));
					}
					else
					{
						$template->assign_vars(array(
							'L_GAME_ERROR'	=>	$user->lang['ERROR_GAME']
						));
						$template->assign_var('S_ERROR', true);
					}
				}
				else
				{
					$template->assign_var('S_ADD_GAME', true);
					$template->assign_var('S_ERROR', true);
					$category_id = request_var('c', 0);
					$game_name = request_var('game_name', '');
					// Grab game details for category display
					$sql = 'SELECT category_id, category_name
						FROM ' . AR_CATEGORIES_TABLE . '
						ORDER BY category_name';
					$result = $db->sql_query($sql);
					$db->sql_freeresult($result);
					while ($row = $db->sql_fetchrow($result))
					{
						$url = $this->u_action . "&amp;c={$row['category_id']}";
						
						$extra = '';
						if ($category_id == $row['category_id'])
						{
							$extra = ' selected="selected"';
						}
						
						// Send vars to template
						$template->assign_block_vars('categoryrow', array(
								'CATEGORY_CODE'	=> '<option value="' . $row['category_id'] .'"' . $extra . '>' . $row['category_name'] . '</option>'
						));
					}
					$url = $this->u_action . "&amp;c=$category_id";
					$template->assign_vars(array(
						'L_GAME_NAME'	=>	$game_name,
						'L_GAME_HEIGHT'	=>	$game_height,
						'L_GAME_WIDTH'	=>	$game_width,
						'L_GAME_DIR'	=>	$game_dir,
						'L_GAME_DESC'	=>	$game_desc,
						'L_GAMECAT'		=>	$game_cat,
						'L_GAME_ERROR'	=>	$error_message,
						'S_HIGHSCORE'	=>	$game_highscore,
						'S_NEWSCORE'	=>	$game_newscore
					));
				}
				$sync = true;
			break;
			case 'editgameinfo':
				$errors = false;
				$error_message = '';
				$game_cat = request_var('game_cat', '');
				$game_id = request_var('g', 0);
				$game_image_type = get_file_type($_FILES['game_image']['name']);
				$image_file_name = file_temp_name('.' . $game_image_type);
				$uploadimagespot = $phpbb_root_path . "arcade/images/" . $image_file_name;
				if ($game_image_type != 'gif' && $game_image_type != 'jpeg' && $game_image_type != 'jpg' && $game_image_type != 'png' && $_FILES['game_image']['name'] != '')
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['WRONG_IMAGE_TYPE'] . '<br />'
					));
				}
				$info = getimagesize($_FILES['game_image']['tmp_name']);
				$create_thumb = false;
				if ($info[0] > 75 || $info[1] > 50)
				{
					$create_thumb = true;
				}
				$remove_image = request_var('remove_image', '');
				if (!$remove_image)
				{
					$remove_image = 0;
				}
				$game_name = request_var('game_name', '');
				if (!$game_name)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_NAME'] . '<br />'
					));
				}
				$game_highscore = request_var('game_highscore', 0);
				if ($game_highscore != 1)
				{
					$game_highscore = 0;
				}
				$game_newscore = request_var('game_newscore', 0);
				if ($game_newscore != 1)
				{
					$game_newscore = 0;
				}
				else
				{
					$game_highscore = 1;
				}
				$game_height = request_var('game_height', '');
				if (!$game_height)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_HEIGHT'] . '<br />'
					));
				}
				$game_width = request_var('game_width', '');
				if (!$game_width)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_WIDTH'] . '<br />'
					));
				}
				$game_cat = request_var('game_cat', '');
				if (!$game_cat)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_CAT'] . '<br />'
					));
				}
				$game_dir = request_var('game_dir', '');
				if (!$game_dir)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_DIR'] . '<br />'
					));
				}
				$game_desc = request_var('game_desc', '');
				if (!$game_desc)
				{
					$errors = true;
					$template->assign_vars(array(
						$error_message = $error_message . $user->lang['SPECIFY_DESC'] . '<br />'
					));
				}
				if ($errors == false)
				{
					if($_FILES['game_image']['name'] != '' && $remove_image == 0)
					{
						if ($create_thumb != true)
						{
							if(!move_uploaded_file($_FILES['game_image']['tmp_name'], $uploadimagespot))
							{
								$template->assign_vars(array(
									'L_GAME_ERROR'	=>	$user->lang['ERROR_IMAGE']
								));
								$template->assign_var('S_ERROR', true);
							}
						}
						else
						{
							$sresult = create_thumbnail($_FILES['game_image']['tmp_name'], $uploadimagespot, 75);
						}
						$sql = 'SELECT game_image
							FROM ' . AR_GAMES_TABLE . '
							WHERE game_id = ' . (int) $game_id;
						$result = $db->sql_query($sql);
						$db->sql_freeresult($result);
						while ($row = $db->sql_fetchrow($result))
						{
							if ($row['game_image'] != 'no_image.gif')
							{
								$imagefile = $phpbb_root_path . "arcade/images/" . $row['game_image'];
								unlink($imagefile);
							}
						}
					}
					else if ($_FILES['game_image']['name'] != '')
					{
						$image_file_name = 'no_image.gif';
						$sql = 'SELECT game_image
							FROM ' . AR_GAMES_TABLE . '
							WHERE game_id = ' . (int) $game_id;
						$result = $db->sql_query($sql);
						$db->sql_freeresult($result);
						while ($row = $db->sql_fetchrow($result))
						{
							if ($row['game_image'] != 'no_image.gif')
							{
								$imagefile = $phpbb_root_path . "arcade/images/" . $row['game_image'];
								unlink($imagefile);
							}
						}
					}
					else
					{
						$sql = 'SELECT game_image
							FROM ' . AR_GAMES_TABLE . '
							WHERE game_id = ' . (int) $game_id;
						$result = $db->sql_query($sql);
						$db->sql_freeresult($result);
						while ($row = $db->sql_fetchrow($result))
						{
							$image_file_name = $row['game_image'];
						}
					}
					$sql_ary = array(
						'game_name'			=> $game_name,
						'game_directions'	=> $game_dir,
						'game_description'	=> $game_desc,
						'game_image'		=> $image_file_name,
						'game_category'		=> $game_cat,
						'game_width'		=> $game_width,
						'game_height'		=> $game_height,
						'game_highscore'	=> $game_highscore,
						'game_newscore'		=> $game_newscore
					);
					$sql = 'UPDATE ' . AR_GAMES_TABLE . ' 
						SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
						WHERE game_id = ' . (int) $game_id;
					$db->sql_query($sql);
					$game_cat = request_var('game_cat', '');
					$sql = 'SELECT *
						FROM ' . AR_CATEGORIES_TABLE . '
						WHERE category_id = ' . (int) $game_cat;
					$result = $db->sql_query($sql);
					$db->sql_freeresult($result);
					while ($row = $db->sql_fetchrow($result))
					{
						$game_cat = $row['category_name'];
					}
					$template->assign_vars(array(
						'L_GAME_NAME'	=>	$game_name,
						'L_GAME_HEIGHT'	=>	$game_height,
						'L_GAME_WIDTH'	=>	$game_width,
						'L_GAME_DIR'	=>	$game_dir,
						'L_GAME_DESC'	=>	$game_desc,
						'L_GAMECAT'		=>	$game_cat,
					));
					$game_cat = request_var('game_cat', '');
					trigger_error($user->lang['GAME_SAVED'] . adm_back_link($this->u_action . "&amp;c=$game_cat"));
				}
				else
				{
					$template->assign_var('S_EDIT_GAME', true);
					$template->assign_var('S_ERROR', true);
					$game_id = request_var('g', 0);
					// Grab game details for game display
					$sql = 'SELECT *
						FROM ' . AR_GAMES_TABLE . '
						WHERE game_id = ' . (int) $game_id;
					$result = $db->sql_query($sql);
					$db->sql_freeresult($result);

					while ($row = $db->sql_fetchrow($result))
					{
						$category_id = $row['game_category'];
					}
					// Grab game details for category display
					$sql = 'SELECT category_id, category_name
						FROM ' . AR_CATEGORIES_TABLE . '
						ORDER BY category_name';
					$result = $db->sql_query($sql);
					$db->sql_freeresult($result);
					while ($row = $db->sql_fetchrow($result))
					{
						$url = $this->u_action . "&amp;c={$row['category_id']}";
						
						$extra = '';
						if ($category_id == $row['category_id'])
						{
							$extra = ' selected="selected"';
						}
						
						// Send vars to template
						$template->assign_block_vars('categoryrow', array(
								'CATEGORY_CODE'	=> '<option value="' . $row['category_id'] .'"' . $extra . '>' . $row['category_name'] . '</option>'
						));
					}
					$template->assign_vars(array(
						'L_GAME_NAME'	=>	$game_name,
						'L_GAME_HEIGHT'	=>	$game_height,
						'L_GAME_WIDTH'	=>	$game_width,
						'L_GAME_DIR'	=>	$game_dir,
						'L_GAME_DESC'	=>	$game_desc,
						'L_GAME_ERROR'	=>	$error_message,
						'S_HIGHSCORE'	=>	$game_highscore,
						'S_REMOVE_IMAGE'=>	$remove_image,
						'S_NEWSCORE'	=>	$game_newscore
					));
				}
				$sync = true;
			break;
			case 'updatesettings':
				$value = request_var('1', 0);
				$sql = 'UPDATE ' . AR_SETTINGS_TABLE . " SET setting_value = $value WHERE setting_id = 1";
				$db->sql_query($sql);
				$value = request_var('2', 0);
				$sql = 'UPDATE ' . AR_SETTINGS_TABLE . " SET setting_value = $value WHERE setting_id = 2";
				$db->sql_query($sql);
				$value = request_var('3', 0);
				$sql = 'UPDATE ' . AR_SETTINGS_TABLE . " SET setting_value = $value WHERE setting_id = 3";
				$db->sql_query($sql);
				$value = request_var('4', 0);
				$sql = 'UPDATE ' . AR_SETTINGS_TABLE . " SET setting_value = $value WHERE setting_id = 4";
				$db->sql_query($sql);
				$value = request_var('5', 0);
				$sql = 'UPDATE ' . AR_SETTINGS_TABLE . " SET setting_value = $value WHERE setting_id = 5";
				$db->sql_query($sql);
				trigger_error($user->lang['SETTINGS_UPDATED'] . adm_back_link($this->u_action));
			break;
		}

		switch ($mode)
		{
			case 'manage':
				if (!$sync)
				{
					$category_id = request_var('c', 0);
					$game_id = request_var('g', 0);
					if ($category_id == 0 && $game_id == 0)
					{
						// Grab game details for category display
						$sql = 'SELECT category_id, category_name
							FROM ' . AR_CATEGORIES_TABLE . '
							ORDER BY category_name';
						$result = $db->sql_query($sql);
						$db->sql_freeresult($result);
	
						$template->assign_var('S_MANAGE_CATEGORY', true);
						$template->assign_var('S_TITLE', $user->lang['CAT_MANAGE']);
						
						$fcount = 0;
						while ($row = $db->sql_fetchrow($result))
						{
							$url = $this->u_action . "&amp;c={$row['category_id']}";
							
							// Send vars to template
							$fcount = $fcount + 1;
							$template->assign_block_vars('categoryrow', array(
									'CATEGORY_ID'		=> $row['category_id'],
									'CATEGORY_NAME'		=> $row['category_name'],
									'COUNT'				=> $fcount,
									'U_CATEGORY'		=> $url,
									'U_DELETE'			=> $url . '&amp;action=deletecategory',
									'U_ACTION'			=> $url
							));
						}
					}
					else if ($game_id == 0)
					{
						// Grab game details for category display
						$sql = 'SELECT category_name
							FROM ' . AR_CATEGORIES_TABLE . '
							WHERE category_id = ' . (int) $category_id;
						$result = $db->sql_query($sql);
						$db->sql_freeresult($result);
						while ($row = $db->sql_fetchrow($result))
						{
							$template->assign_var('S_TITLE', $user->lang['GAME_MANAGE'] . ' &laquo; ' . $row['category_name']);
						}
						// Grab game details for game display
						$sql = 'SELECT *
							FROM ' . AR_GAMES_TABLE . '
							WHERE game_category = ' . (int) $category_id . '
							ORDER BY game_name';
						$result = $db->sql_query($sql);
						$db->sql_freeresult($result);
	
						$template->assign_var('S_MANAGE_GAME', true);

						$fcount = 0;
						while ($row = $db->sql_fetchrow($result))
						{
							$addurl = $this->u_action;
							$url = $this->u_action . "&amp;g={$row['game_id']}";
							
							// Send vars to template
							$fcount = $fcount + 1;
							$template->assign_block_vars('gamerow', array(
									'GAME_ID'		=> $row['game_id'],
									'GAME_NAME'		=> $row['game_name'],
									'COUNT'			=> $fcount,
									'U_GAME'		=> $url,
									'U_DELETE'		=> $url . '&amp;action=deletegame',
									'U_ACTION'		=> $addurl . '&amp;action=addgane'
							));
						}
					}
					else
					{
						// Grab game details for game display
						$sql = 'SELECT *
							FROM ' . AR_GAMES_TABLE . '
							WHERE game_id = ' . (int) $game_id;
						$result = $db->sql_query($sql);
						$db->sql_freeresult($result);
	
						$template->assign_var('S_EDIT_GAME', true);

						while ($row = $db->sql_fetchrow($result))
						{
							$template->assign_vars(array(
								'L_GAME_NAME'	=>	$row['game_name'],
								'L_GAME_HEIGHT'	=>	$row['game_height'],
								'L_GAME_WIDTH'	=>	$row['game_width'],
								'L_GAME_DIR'	=>	$row['game_directions'],
								'L_GAME_DESC'	=>	$row['game_description'],
							));
							$category_id = $row['game_category'];
						}
						// Grab game details for category display
						$sql = 'SELECT category_id, category_name
							FROM ' . AR_CATEGORIES_TABLE . '
							ORDER BY category_name';
						$result = $db->sql_query($sql);
						$db->sql_freeresult($result);
						while ($row = $db->sql_fetchrow($result))
						{
							$url = $this->u_action . "&amp;c={$row['category_id']}";
							
							$extra = '';
							if ($category_id == $row['category_id'])
							{
								$extra = ' selected="selected"';
							}
							
							// Send vars to template
							$template->assign_block_vars('categoryrow', array(
									'CATEGORY_CODE'	=> '<option value="' . $row['category_id'] .'"' . $extra . '>' . $row['category_name'] . '</option>'
							));
						}
					}
				}
			break;
			case 'settings':
			if (!$sync)
			{
				$requestfile = 'http://www.gfx-pros.com/phpAR2/phpARversion.txt';
				if (@$viewfile = file_get_contents($requestfile))
				{
					$curver = $user->lang['AR_VERSION'];
					$url = $this->u_action . "&amp;action=update";
					$updateinfo = $user->lang['UPDATE_INFO'] . ' <strong>' . $curver . '</strong> ' . $user->lang['OUT_OF_DATE'] . ' <strong>' . $viewfile . '</strong> ' . $user->lang['OUT_NOW'] . ' <br /><a href="'.$url.'" target="_blank">' . $user->lang['CLICK_UPDATE'] . '</a>';
					if (version_compare($viewfile, $curver, '>='))
					{
						$template->assign_var('L_ARCADE_RESYNCED', $updateinfo);
						$template->assign_var('S_UPDATE', true);
					}
					else
					{
						$template->assign_var('L_ARCADE_RESYNCED', $user->lang['YOUR'] . ' <strong>' . $curver . '</strong> ' . $user->lang['UP_TO_DATE']);
						$template->assign_var('S_RESYNCED', true);
					}
				}
				else
				{
					$template->assign_var('L_ARCADE_RESYNCED', $user->lang['SERVER_ERROR']);
					$template->assign_var('S_UPDATE', true);
				}
				
				$template->assign_var('L_NOTIFY', 'Update Notifications');
				$template->assign_var('S_SETTINGS', true);
				// Grab game details for category display
				$sql = 'SELECT *
					FROM ' . AR_SETTINGS_TABLE . '
					ORDER BY setting_id';
				$result = $db->sql_query($sql);
				$db->sql_freeresult($result);
				while ($row = $db->sql_fetchrow($result))
				{					
					// Send vars to template
					$template->assign_block_vars('settingrow', array(
							'ID'		=> $row['setting_id'],
							'NAME'		=> $row['setting_name'],
							'CONTENT'	=> $row['setting_value']
					));
				}
			}
			break;
		}
	}
}

?>