<?php
/** 
*
* @package phpAR
* @version $Id: install.php
* @copyright (c) 2007 gfxPros
* @website http://www.gfx-pros.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/file_functions.' . $phpEx);

define('AR_CATEGORIES_TABLE',		$table_prefix . 'ar_categories');
define('AR_GAMES_TABLE',			$table_prefix . 'ar_games');
define('AR_RATINGS_TABLE',			$table_prefix . 'ar_ratings');
define('AR_SETTINGS_TABLE',			$table_prefix . 'ar_settings');
define('AR_COMMENTS_TABLE',			$table_prefix . 'ar_comments');
define('AR_FAVORITES_TABLE',		$table_prefix . 'ar_favorites');
define('AR_HOTLINKS_TABLE',			$table_prefix . 'ar_hotlinks');
define('AR_HIGHSCORES_TABLE',		$table_prefix . 'ar_highscores');
define('AR_VIEWING_TABLE',			$table_prefix . 'ar_viewing');

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/arcade');
// End session management

if (!$user->data['is_registered'])
{
    if ($user->data['is_bot'])
    {
        redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
    }
    login_box('', 'LOGIN');
}
else if ($user->data['user_type'] != USER_FOUNDER)
{
    die('You are not the board founder.');
}

$titlefont = '<font color="#0077AA">';
$goodfont = '<font color="#007700">';
$okfont = '<font color="#AA7700">';
$badfont = '<font color="#770000">';
$cfont = '</font>';

// Output page
page_header($user->lang['ARCADE']);

$template->set_filenames(array(
	'body' => 'arcade_install.html')
);

$db->sql_return_on_error(true);

$action	= request_var('action', '');

$message = '';

switch ($action)
{
	default:
		$message .= $titlefont . $user->lang['AR_WELCOME'] . '<br /><br />' . $user->lang['AR_EXPLAIN'] . '<br /><br />' . $user->lang['AR_TO_BEGIN'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'install.' . $phpEx,
			'L_VALUE'	=> 'mysql',
			'L_BUTTON'	=> $user->lang['BEGIN']
		));
	break;
	case 'mysql':
		switch ($db->sql_layer)
		{
			case 'mysql':
				$db_type = 'mysql_40';
			break;
		
			case 'mysql4':
				if (version_compare($db->mysql_version, '4.1.3', '>='))
				{
					$db_type = 'mysql_41';
				}
				else
				{
					$db_type = 'mysql_40';
				}
			break;
		
			case 'mysqli':
				$db_type = 'mysql_41';
			break;
		
			default:
				$db_type = $db->sql_layer;
			break;
		}
		$message .= $titlefont . $user->lang['MYSQL_EDITS'] . $cfont;
		
		if(!$db->sql_query("SELECT * FROM " . AR_CATEGORIES_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_CATEGORIES_TABLE . " (
				  category_id mediumint(8) unsigned NOT NULL auto_increment,
				  category_name varchar(255) NOT NULL default '',
				  PRIMARY KEY  (category_id)
				)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_CATEGORIES_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_CATEGORIES_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_CATEGORIES_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		
		if(!$db->sql_query("SELECT * FROM " . AR_GAMES_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_GAMES_TABLE . " (
				  game_id mediumint(8) unsigned NOT NULL auto_increment,
				  game_name varchar(100) NOT NULL default '',
				  game_image varchar(255) NOT NULL default 'no_image.gif',
				  game_directions varchar(255) NOT NULL default '',
				  game_description varchar(255) NOT NULL default '',
				  game_category mediumint(8) unsigned NOT NULL default '0',
				  game_filename varchar(255) NOT NULL default '',
				  game_filesize int(20) unsigned NOT NULL default '0',
				  game_plays mediumint(8) unsigned NOT NULL default '0',
				  game_rating mediumint(8) NOT NULL default '0',
				  game_num_ratings mediumint(8) NOT NULL default '0',
				  game_width mediumint(8) unsigned NOT NULL default '0',
				  game_height mediumint(8) unsigned NOT NULL default '0',
				  game_highscore tinyint(1) unsigned NOT NULL default '0',
				  game_newscore tinyint(1) unsigned NOT NULL default '0',
				  PRIMARY KEY  (game_id)
				)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_GAMES_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_GAMES_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_GAMES_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		
		if(!$db->sql_query("SELECT * FROM " . AR_RATINGS_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_RATINGS_TABLE . " (
				  rating_id mediumint(8) NOT NULL auto_increment,
				  rating_game mediumint(8) NOT NULL default '0',
				  rating_user mediumint(8) NOT NULL default '0',
				  rating_score mediumint(8) NOT NULL default '0',
				  PRIMARY KEY  (rating_id)
				)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_RATINGS_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_RATINGS_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_RATINGS_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		
		if(!$db->sql_query("SELECT * FROM " . AR_SETTINGS_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_SETTINGS_TABLE . " (
				  setting_id mediumint(8) NOT NULL auto_increment,
				  setting_name varchar(255) NOT NULL default '',
				  setting_value varchar(255) NOT NULL default '0',
				  PRIMARY KEY  (setting_id)
				)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_SETTINGS_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_SETTINGS_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_SETTINGS_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		
		$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 1';
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		$db->sql_freeresult($result);
		if (!$row_count)
		{
			$sql = 'INSERT INTO ' . AR_SETTINGS_TABLE . " VALUES (1, '" . $user->lang['ALLOW_GUEST'] . "', '0')";
			$db->sql_query($sql);
		}
		$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 2';
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		$db->sql_freeresult($result);
		if (!$row_count)
		{
			$sql = 'INSERT INTO ' . AR_SETTINGS_TABLE . " VALUES (2, '" . $user->lang['GUEST_INCREASE'] . "', '0')";
			$db->sql_query($sql);
		}
		$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 3';
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		$db->sql_freeresult($result);
		if (!$row_count)
		{
			$sql = 'INSERT INTO ' . AR_SETTINGS_TABLE . " VALUES (3, '" . $user->lang['ALLOW_COMMENTS'] . "', '0')";
			$db->sql_query($sql);
		}
		$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 4';
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		$db->sql_freeresult($result);
		if (!$row_count)
		{
			$sql = 'INSERT INTO ' . AR_SETTINGS_TABLE . " VALUES (4, '" . $user->lang['ENABLE_HOTLINK'] . "', '0')";
			$db->sql_query($sql);
		}
		$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 5';
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		$db->sql_freeresult($result);
		if (!$row_count)
		{
			$sql = 'INSERT INTO ' . AR_SETTINGS_TABLE . " VALUES (5, '" . $user->lang['ENABLE_FAVORITES'] . "', '0')";
			$db->sql_query($sql);
		}
		
		if(!$db->sql_query("SELECT * FROM " . AR_COMMENTS_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_COMMENTS_TABLE . " (
				  comment_id mediumint(8) unsigned NOT NULL auto_increment,
				  comment_user mediumint(8) unsigned NOT NULL default '0',
				  comment_game mediumint(8) unsigned NOT NULL default '0',
				  comment varchar(255) NOT NULL default '',
				  bbcode_uid varchar(5) NOT NULL default '',
				  bbcode_bitfield varchar(255) NOT NULL default '',
				  enable_bbcode tinyint(1) unsigned NOT NULL default '1',
				  enable_smilies tinyint(1) unsigned NOT NULL default '1',
				  enable_urls tinyint(1) unsigned NOT NULL default '1',
				  PRIMARY KEY  (comment_id)
				)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_COMMENTS_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_COMMENTS_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_COMMENTS_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		
		if(!$db->sql_query("SELECT * FROM " . AR_FAVORITES_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_FAVORITES_TABLE . " (
			  favorite_id mediumint(8) unsigned NOT NULL auto_increment,
			  favorite_game mediumint(8) unsigned NOT NULL,
			  favorite_user mediumint(8) unsigned NOT NULL,
			  PRIMARY KEY  (favorite_id)
			)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_FAVORITES_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_FAVORITES_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_FAVORITES_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		
		if(!$db->sql_query("SELECT * FROM " . AR_HOTLINKS_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_HOTLINKS_TABLE . " (
			  hotlink_id mediumint(8) unsigned NOT NULL auto_increment,
			  hotlink_game mediumint(8) unsigned NOT NULL,
			  hotlink_file varchar(255) NOT NULL,
			  PRIMARY KEY  (hotlink_id)
			)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_HOTLINKS_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_HOTLINKS_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_HOTLINKS_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		if(!$db->sql_query("SELECT * FROM " . AR_HIGHSCORES_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_HIGHSCORES_TABLE . " (
				  highscore_id mediumint(8) unsigned NOT NULL auto_increment,
				  highscore_game mediumint(8) unsigned NOT NULL,
				  highscore_user mediumint(8) unsigned NOT NULL,
				  highscore int(20) unsigned NOT NULL,
				  PRIMARY KEY  (highscore_id)
				)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_HIGHSCORES_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_HIGHSCORES_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_HIGHSCORES_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		if(!$db->sql_query("SELECT * FROM " . AR_VIEWING_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_VIEWING_TABLE . " (
				  viewing_id mediumint(8) unsigned NOT NULL auto_increment,
				  viewing_user mediumint(8) unsigned NOT NULL,
				  viewing_game mediumint(8) unsigned NOT NULL,
				  PRIMARY KEY  (viewing_id)
				)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_VIEWING_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_VIEWING_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_HIGHSCORES_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		$message .= $titlefont . '<br /><br />' . $user->lang['MYSQL_DONE'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'install.' . $phpEx,
			'L_VALUE'	=> 'modules',
			'L_BUTTON'	=> $user->lang['ADD_MODULES']
		));
	break;
	case 'modules':
		$message .= $titlefont . $user->lang['ACP_MODULES'] . $cfont;
		
		$sql = 'SELECT COUNT(module_langname) AS row_count FROM ' . MODULES_TABLE . " WHERE module_langname = 'Arcade Room'";
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		$db->sql_freeresult($result);
		if(!$row_count)
		{
			$sql = array();
		
			$sql = 'SELECT * FROM ' . MODULES_TABLE . " WHERE module_langname = 'ACP_CAT_DOT_MODS'";
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);
			$sql_ary = array(
				'module_enabled'	=> 1,
				'module_display'	=> 1,
				'module_basename'	=> '',
				'module_class'		=> 'acp',
				'parent_id'			=> $row['module_id'],
				'left_id'			=> $row['right_id'],
				'right_id'			=> $row['right_id'] + 5,
				'module_langname'	=> 'Arcade Room',
				'module_mode'		=> '',
				'module_auth'		=> '',
			);
			
			$sql = 'INSERT INTO ' . MODULES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
			$module_id = $db->sql_nextid();
			
			$sql = 'UPDATE ' . MODULES_TABLE . "
			SET left_id = left_id + 6, right_id = right_id + 6
			WHERE left_id >= {$sql_ary['left_id']} AND module_id != $module_id";
			$db->sql_query($sql);
								
			$sql = 'UPDATE ' . MODULES_TABLE . "
			SET right_id = right_id + 6
			WHERE left_id < {$sql_ary['left_id']} AND right_id >= {$sql_ary['left_id']} AND module_id != $module_id";
			$db->sql_query($sql);
			
			$sql_ary = array(
				'module_enabled'	=> 1,
				'module_display'	=> 1,
				'module_basename'	=> 'arcade',
				'module_class'		=> 'acp',
				'parent_id'			=> $module_id,
				'left_id'			=> $row['right_id'] + 1,
				'right_id'			=> $row['right_id'] + 2,
				'module_langname'	=> 'Arcade Settings',
				'module_mode'		=> 'settings',
				'module_auth'		=> 'acl_a_board',
			);
			
			$sql = 'INSERT INTO ' . MODULES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
			
			$sql_ary = array(
				'module_enabled'    => 1,
				'module_display'    => 1,
				'module_basename'	=> 'arcade',
				'module_class'		=> 'acp',
				'parent_id'			=> $module_id,
				'left_id'			=> $row['right_id'] + 3,
				'right_id'			=> $row['right_id'] + 4,
				'module_langname'	=> 'Manage Arcade',
				'module_mode'		=> 'manage',
				'module_auth'		=> 'acl_a_board',
			);
			
			$sql = 'INSERT INTO ' . MODULES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
		
			$message .= $goodfont . '<br />' . $user->lang['ACP_ADDED'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $user->lang['ACP_EXISTS'] . $cfont;
		}
		$sql = 'SELECT COUNT(module_langname) AS row_count FROM ' . MODULES_TABLE . " WHERE module_langname = 'Arcade'";
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		$db->sql_freeresult($result);
		if(!$row_count)
		{
			$sql = 'SELECT MAX(right_id) AS total_right FROM ' . MODULES_TABLE . " WHERE module_class = 'ucp'";
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);
			
			$sql_ary = array(
				'module_enabled'	=> 1,
				'module_display'	=> 1,
				'module_basename'	=> '',
				'module_class'		=> 'ucp',
				'parent_id'			=> 0,
				'left_id'			=> $row['total_right'] + 1,
				'right_id'			=> $row['total_right'] + 4,
				'module_langname'	=> 'Arcade',
				'module_mode'		=> '',
				'module_auth'		=> '',
			);
			
			$sql = 'INSERT INTO ' . MODULES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
			$module_id = $db->sql_nextid();
			
			$sql_ary = array(
				'module_enabled'	=> 1,
				'module_display'	=> 1,
				'module_basename'	=> 'arcade',
				'module_class'		=> 'ucp',
				'parent_id'			=> $module_id,
				'left_id'			=> $row['total_right'] + 2,
				'right_id'			=> $row['total_right'] + 3,
				'module_langname'	=> 'Favorite Games',
				'module_mode'		=> 'favorites',
				'module_auth'		=> '',
			);
			
			$sql = 'INSERT INTO ' . MODULES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
			
			$message .= $goodfont . '<br />' . $user->lang['UCP_ADDED'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $user->lang['UCP_EXISTS'] . $cfont;
		}
		$message .= $titlefont . '<br /><br />' . $user->lang['MODULES_DONE'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'install.' . $phpEx,
			'L_VALUE'	=> 'edits',
			'L_BUTTON'	=> $user->lang['EDIT_FILES']
		));
	break;
	case 'edits':
		/**
		* Key:
		* $fe stands for file
		* $fd stands for find
		* $ad stands for add
		* $re stands for replace
		*/
		$message .= $titlefont . $user->lang['FILE_EDITS'] . $cfont;

		$fe = 'styles/prosilver/theme/colours.css';
		$fd = '.icon-members					{ background-image: url("{T_THEME_PATH}/images/icon_members.gif"); }';
		$ad = '
.icon-arcade					{ background-image: url("{T_THEME_PATH}/images/icon_arcade.gif"); }';
		if (file_add_after($fe, $fd, $ad))
		{
			$message .= $goodfont . '<br />' . $fe . $user->lang['EDIT_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $fe . $user->lang['EDITED_ALREADY'] . $cfont;
		}
		
		$fe = 'styles/prosilver/theme/buttons.css';
		$fd = ', .icon-members, ';
		$ad = '.icon-arcade, ';
		if (file_add_after($fe, $fd, $ad))
		{
			$message .= $goodfont . '<br />' . $fe . $user->lang['EDIT_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $fe . $user->lang['EDITED_ALREADY'] . $cfont;
		}
		
		$fe = 'styles/prosilver/theme/buttons.css';
		$fd = ', .rtl .icon-members, ';
		$ad = '.rtl .icon-arcade, ';
		if (file_add_after($fe, $fd, $ad))
		{
			$message .= $goodfont . '<br />' . $fe . $user->lang['EDIT_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $fe . $user->lang['EDITED_ALREADY'] . $cfont;
		}
		
		$fe = 'styles/prosilver/template/overall_header.html';
		$fd = '<!-- IF S_DISPLAY_MEMBERLIST --><a href="{U_MEMBERLIST}" title="{L_MEMBERLIST_EXPLAIN}" class="icon-members">{L_MEMBERLIST}</a>&nbsp; <!-- ENDIF -->';
		$ad = '
		<a href="arcade.php" title="Visit the arcade room" class="icon-arcade">Arcade Room</a>&nbsp;';
		if (file_add_after($fe, $fd, $ad))
		{
			$message .= $goodfont . '<br />' . $fe . $user->lang['EDIT_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $fe . $user->lang['EDITED_ALREADY'] . $cfont;
		}
		
		$fe = 'styles/prosilver/template/overall_header.html';
		$fd = '<!-- BEGIN navlinks --> <strong>&#8249;</strong> <a href="{navlinks.U_VIEW_FORUM}">{navlinks.FORUM_NAME}</a><!-- END navlinks -->';
		$re = '<!-- IF S_ARCADE --><!-- BEGIN navlinks --> <strong>&#8249;</strong> <a href="{navlinks.U_VIEW_ARCADE}">{navlinks.ARCADE_NAME}</a><!-- END navlinks --><!-- ELSE --><!-- BEGIN navlinks --> <strong>&#8249;</strong> <a href="{navlinks.U_VIEW_FORUM}">{navlinks.FORUM_NAME}</a><!-- END navlinks --><!-- ENDIF -->';
		if (file_replace($fe, $fd, $re))
		{
			$message .= $goodfont . '<br />' . $fe . $user->lang['EDIT_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $fe . $user->lang['EDITED_ALREADY'] . $cfont;
		}
		
		$fe = 'styles/prosilver/template/overall_footer.html';
		$fd = '<div class="copyright">';
		$ad = '<!-- IF S_ARCADE -->{L_ARCADE} {L_AR_VERSION} for phpBB by <a href="http://www.gfx-pros.com/home.html">gfxPros</a> &copy; 2007<br /><!-- ENDIF -->';
		if (file_add_after($fe, $fd, $ad))
		{
			$message .= $goodfont . '<br />' . $fe . $user->lang['EDIT_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $fe . $user->lang['EDITED_ALREADY'] . $cfont;
		}
		
		$fe = 'includes/constants.php';
		$fd = '?>';
		$ad = 'define(\'AR_CATEGORIES_TABLE\',		$table_prefix . \'ar_categories\');
define(\'AR_GAMES_TABLE\',			$table_prefix . \'ar_games\');
define(\'AR_RATINGS_TABLE\',			$table_prefix . \'ar_ratings\');
define(\'AR_SETTINGS_TABLE\',			$table_prefix . \'ar_settings\');
define(\'AR_COMMENTS_TABLE\',			$table_prefix . \'ar_comments\');
define(\'AR_FAVORITES_TABLE\',		$table_prefix . \'ar_favorites\');
define(\'AR_HOTLINKS_TABLE\',			$table_prefix . \'ar_hotlinks\');
define(\'AR_HIGHSCORES_TABLE\',		$table_prefix . \'ar_highscores\');
define(\'AR_VIEWING_TABLE\',			$table_prefix . \'ar_viewing\');

';
		if (file_add_before($fe, $fd, $ad))
		{
			$message .= $goodfont . '<br />' . $fe . $user->lang['EDIT_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $fe . $user->lang['EDITED_ALREADY'] . $cfont;
		}
		
		$fe = 'common.php';
		$fd = '?>';
		$ad = '// For hotlink protection to remove games properly after the time the game expires
$sql = \'SELECT hotlink_id, hotlink_file
	FROM \' . AR_HOTLINKS_TABLE;
$result = $db->sql_query($sql);
while ($row = $db->sql_fetchrow($result))
{
	$time = time();
	$temp_file = $phpbb_root_path . $row[\'hotlink_file\'];
	$file_life = $time - filemtime($temp_file);
	if ($file_life > 60)
	{
		unlink($temp_file);
		$sql2 = \'DELETE FROM \' . AR_HOTLINKS_TABLE . \' WHERE hotlink_id = \' . (int) $row[\'hotlink_id\'];
		$db->sql_query($sql2);
	}
}
$db->sql_freeresult($result);
';
		if (file_add_before($fe, $fd, $ad))
		{
			$message .= $goodfont . '<br />' . $fe . $user->lang['EDIT_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $fe . $user->lang['EDITED_ALREADY'] . $cfont;
		}
		
		$message .= $titlefont . '<br /><br />' . $user->lang['EDITS_DONE'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'install.' . $phpEx,
			'L_VALUE'	=> 'finish',
			'L_BUTTON'	=> $user->lang['FINISH']
		));
	break;
	case 'finish':
		$message .= $titlefont . $user->lang['IF_OK'] . '<br />' . $user->lang['IF_OK_NEW'] . $cfont;
		$message .= $titlefont . '<br /><br />' . $user->lang['FINAL_STEPS'] . $cfont;
		global $cache;
		$cache->purge();
		add_log('admin', 'LOG_PURGE_CACHE');
		$template->assign_vars(array(
			'U_ACTION'	=> 'install.' . $phpEx,
			'L_VALUE'	=> 'delete',
			'L_BUTTON'	=> $user->lang['DELETE']
		));
	break;
	case 'delete':
		unlink('install.php');
		header("Location: index.php");
	break;
}

$template->assign_vars(array(
		'L_MESSAGE'		=>	$message,
		'S_INSTALL'		=>	true,
		'S_ARCADE'		=>	true
));

page_footer();

?>