<?php
/** 
*
* @package phpAR
* @version $Id: update.php
* @copyright (c) 2007 gfxPros
* @website http://www.gfx-pros.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/file_functions.' . $phpEx);

define('AR_HIGHSCORES_TABLE',		$table_prefix . 'ar_highscores');
define('AR_VIEWING_TABLE',			$table_prefix . 'ar_viewing');

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/arcade');
// End session management

if (!$user->data['is_registered'])
{
    if ($user->data['is_bot'])
    {
        redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
    }
    login_box('', 'LOGIN');
}
else if ($user->data['user_type'] != USER_FOUNDER)
{
    die('You are not the board founder.');
}

$titlefont = '<font color="#0077AA">';
$goodfont = '<font color="#007700">';
$okfont = '<font color="#AA7700">';
$badfont = '<font color="#770000">';
$cfont = '</font>';

// Output page
page_header($user->lang['ARCADE']);

$template->set_filenames(array(
	'body' => 'arcade_install.html')
);

$db->sql_return_on_error(true);

$action	= request_var('action', '');

$message = '';

switch ($action)
{
	default:
		$message .= $titlefont . $user->lang['AR_WELCOME'] . '<br /><br />' . $user->lang['AR_EXPLAIN'] . '<br /><br />' . $user->lang['AR_TO_BEGIN'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'update_0.5.0-0.6.5.' . $phpEx,
			'L_VALUE'	=> 'mysql',
			'L_BUTTON'	=> $user->lang['BEGIN']
		));
	break;
	case 'mysql':
		switch ($db->sql_layer)
		{
			case 'mysql':
				$db_type = 'mysql_40';
			break;
		
			case 'mysql4':
				if (version_compare($db->mysql_version, '4.1.3', '>='))
				{
					$db_type = 'mysql_41';
				}
				else
				{
					$db_type = 'mysql_40';
				}
			break;
		
			case 'mysqli':
				$db_type = 'mysql_41';
			break;
		
			default:
				$db_type = $db->sql_layer;
			break;
		}
		$message .= $titlefont . $user->lang['MYSQL_EDITS'] . $cfont;
		
		if(!$db->sql_query("SELECT * FROM " . AR_HIGHSCORES_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_HIGHSCORES_TABLE . " (
				  highscore_id mediumint(8) unsigned NOT NULL auto_increment,
				  highscore_game mediumint(8) unsigned NOT NULL,
				  highscore_user mediumint(8) unsigned NOT NULL,
				  highscore int(20) unsigned NOT NULL,
				  PRIMARY KEY  (highscore_id)
				)";
			
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_HIGHSCORES_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_HIGHSCORES_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_HIGHSCORES_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		if(!$db->sql_query("SELECT * FROM " . AR_VIEWING_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_VIEWING_TABLE . " (
				  viewing_id mediumint(8) unsigned NOT NULL auto_increment,
				  viewing_user mediumint(8) unsigned NOT NULL,
				  viewing_game mediumint(8) unsigned NOT NULL,
				  PRIMARY KEY  (viewing_id)
				)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_VIEWING_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_VIEWING_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_VIEWING_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		$sql = 'ALTER TABLE ' .  AR_GAMES_TABLE . "
			ADD game_highscore TINYINT( 1 ) UNSIGNED DEFAULT '0' NOT NULL ,
			ADD `game_newscore` TINYINT( 1 ) UNSIGNED DEFAULT '0' NOT NULL";
		if ($db->sql_query($sql))
		{
			$message .= $goodfont . '<br />' . AR_GAMES_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $badfont . '<br />' . AR_GAMES_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
		}
		$message .= $titlefont . '<br /><br />' . $user->lang['MYSQL_DONE'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'update_0.5.0-0.6.5.' . $phpEx,
			'L_VALUE'	=> 'modules',
			'L_BUTTON'	=> $user->lang['ADD_MODULES']
		));
	break;
	case 'modules':
		$message .= $titlefont . $user->lang['ACP_MODULES'] . $cfont;
		
		$sql = 'SELECT COUNT(module_langname) AS row_count FROM ' . MODULES_TABLE . " WHERE module_langname = 'Arcade'";
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		$db->sql_freeresult($result);
		if(!$row_count)
		{
			$sql = 'SELECT MAX(right_id) AS total_right FROM ' . MODULES_TABLE . " WHERE module_class = 'ucp'";
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);
			
			$sql_ary = array(
				'module_enabled'	=> 1,
				'module_display'	=> 1,
				'module_basename'	=> '',
				'module_class'		=> 'ucp',
				'parent_id'			=> 0,
				'left_id'			=> $row['total_right'] + 1,
				'right_id'			=> $row['total_right'] + 4,
				'module_langname'	=> 'Arcade',
				'module_mode'		=> '',
				'module_auth'		=> '',
			);
			
			$sql = 'INSERT INTO ' . MODULES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
			$module_id = $db->sql_nextid();
			
			$sql_ary = array(
				'module_enabled'	=> 1,
				'module_display'	=> 1,
				'module_basename'	=> 'arcade',
				'module_class'		=> 'ucp',
				'parent_id'			=> $module_id,
				'left_id'			=> $row['total_right'] + 2,
				'right_id'			=> $row['total_right'] + 3,
				'module_langname'	=> 'Favorite Games',
				'module_mode'		=> 'favorites',
				'module_auth'		=> '',
			);
			
			$sql = 'INSERT INTO ' . MODULES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
			
			$message .= $goodfont . '<br />' . $user->lang['UCP_ADDED'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $user->lang['UCP_EXISTS'] . $cfont;
		}
		$message .= $titlefont . '<br /><br />' . $user->lang['MODULES_DONE'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'update_0.5.0-0.6.5.' . $phpEx,
			'L_VALUE'	=> 'edits',
			'L_BUTTON'	=> $user->lang['EDIT_FILES']
		));
	break;
	case 'edits':
		/**
		* Key:
		* $fe stands for file
		* $fd stands for find
		* $ad stands for add
		* $re stands for replace
		*/
		$message .= $titlefont . $user->lang['FILE_EDITS'] . $cfont;

		$fe = 'includes/constants.php';
		$fd = 'define(\'AR_HOTLINKS_TABLE\',			$table_prefix . \'ar_hotlinks\');';
		$ad = '
define(\'AR_HIGHSCORES_TABLE\',		$table_prefix . \'ar_highscores\');
define(\'AR_VIEWING_TABLE\',			$table_prefix . \'ar_viewing\');';
		if (file_add_before($fe, $fd, $ad))
		{
			$message .= $goodfont . '<br />' . $fe . $user->lang['EDIT_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $okfont . '<br />' . $fe . $user->lang['EDITED_ALREADY'] . $cfont;
		}
		$message .= $titlefont . '<br /><br />' . $user->lang['EDITS_DONE'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'update_0.5.0-0.6.5.' . $phpEx,
			'L_VALUE'	=> 'finish',
			'L_BUTTON'	=> $user->lang['COPY_FILES']
		));
	break;
	case 'finish':
		$message .= $titlefont . $user->lang['IF_OK'] . '<br />' . $user->lang['IF_OK_NEW'] . $cfont;
		$message .= $titlefont . '<br /><br />' . $user->lang['FINAL_STEPS'] . $cfont;
		global $cache;
		$cache->purge();
		add_log('admin', 'LOG_PURGE_CACHE');
		$template->assign_vars(array(
			'U_ACTION'	=> 'update_0.5.0-0.6.5.' . $phpEx,
			'L_VALUE'	=> 'delete',
			'L_BUTTON'	=> $user->lang['DELETE']
		));
	break;
	case 'delete':
		unlink('update_0.5.0-0.6.5.php');
		header("Location: index.php");
	break;
}

$template->assign_vars(array(
		'L_MESSAGE'		=>	$message,
		'S_INSTALL'		=>	true,
		'S_ARCADE'		=>	true
));

page_footer();

?>